import java.util.Map;
import okuyama.imdst.client.OkuyamaClient;
import okuyama.imdst.client.OkuyamaClientException;

public class OkuyamaTest {
    public static void main(String[] args) {
        // NCAgCX^X쐬
        OkuyamaClient okuyamaClient = new OkuyamaClient();
        try {
            if (args.length != 2) {
                System.out.println("usage : MasterNodeAddress MasterNodePort");
                System.exit(1);
            }

            // "Address:Port"̃tH[}bgɕύX
            String masterNodeConnectInfo = args[0] + ":" + args[1];

            // ClientMasterNodȅo^
            String[] masterNodeInfos = {masterNodeConnectInfo};
            okuyamaClient.setConnectionInfos(masterNodeInfos);

            // MasterNodeɐڑ
            okuyamaClient.autoConnect();

            // lo^
            if (okuyamaClient.setValue("Key_00001", "Value_00001")) {
                System.out.println("o^");
            } else {
                System.out.println("o^s");
            }

            // l擾
            String[] getResult = okuyamaClient.getValue("Key_00001");
            if (getResult[0].equals("true")) {
                System.out.println("擾");
                System.out.println(getResult[1]);
            } else {
                System.out.println("擾s");
            }

            // Tag𓯎ɓo^
            String[] tags = {"tag1", "tag2"};
            if (okuyamaClient.setValue("Key_00002", tags, "Value_00002")) {
                System.out.println("o^");
            } else {
                System.out.println("o^s");
            }

            // Tagł̎擾
            // Keŷݎ擾
            Object[] tagKeysResult = okuyamaClient.getTagKeys("tag1");
            if (tagKeysResult[0].equals("true")) {
                System.out.println("擾");
                String[] keys = (String[])tagKeysResult[1];
                System.out.println(keys[0]);
            } else {
                System.out.println("擾s");
            }

            // KeyValuẽZbg擾
            Map tagValuesMap = okuyamaClient.getTagValues("tag1");
            if (tagValuesMap != null) {
                System.out.println("擾");
                System.out.println(tagValuesMap);
            } else {
                System.out.println("擾s");
            }

            // Tagw(ORw)
            String[] multiTags = {"tag1", "tag999"};
            Map multiTagValuesMap = okuyamaClient.getMultiTagValues(multiTags, false);
            if (multiTagValuesMap != null) {
                System.out.println("擾");
                System.out.println(multiTagValuesMap);
            } else {
                System.out.println("擾s");
            }

            // Key-ValueRtTag폜
            if (okuyamaClient.removeTagFromKey("Key_00002", "tag1")) {
                System.out.println("폜");
            } else {
                System.out.println("폜s");
            }

// rIXVs(CAS)
            // rIXVɗpVersionNo𓯎Ɏ擾
            String[] getResultVer = okuyamaClient.getValueVersionCheck("Key_00001");
            if (getResultVer[0].equals("true")) {
                // rIXVs
                String[] setResultVer = okuyamaClient.setValueVersionCheck("Key_00001", "Value_99999", getResultVer[2]);
                if (setResultVer[0].equals("true")) {
                    System.out.println("rIXV");
                } else {
                    System.out.println("rIXVs");
                }
            } else {
                System.out.println("擾s");
            }

            // Key-ValuẽZbg폜
            String[] removeResult = okuyamaClient.removeValue("Key_00001");

            if (removeResult[0].equals("true")) {
                System.out.println("폜");
                System.out.println(removeResult[1]);
            } else {
                System.out.println("폜s");
            }

            // SIndex쐬
            // Index̃O[v"GRP1"Ǝw
            if(okuyamaClient.setValueAndCreateIndex("Key_01000", "Value_ABCDEFG", "GRP1")) {
                System.out.println("SIndex쐬");
            } else {
                System.out.println("SIndex쐬s");
            }
            if(okuyamaClient.setValueAndCreateIndex("Key_01001", "Value_FGHIJKL", "GRP1")) {
                System.out.println("SIndex쐬");
            } else {
                System.out.println("SIndex쐬s");
            }
            if(okuyamaClient.setValueAndCreateIndex("Key_01002", "Value_KLMNOPQ", "GRP1")) {
                System.out.println("SIndex쐬");
            } else {
                System.out.println("SIndex쐬s");
            }
            // Ss
            String[] keyWord1 = {"FG"}; // Key_01000, Key_01001擾o
            Object[] searchResult1 = okuyamaClient.searchValue(keyWord1, OkuyamaClient.SEARCH_VALUE_TYPE_AND, "GRP1");
            if (searchResult1[0].equals("true")) {
                String[] searchResultKeys = (String[])searchResult1[1];
                for (int idx = 0; idx < searchResultKeys.length; idx++) {
                    System.out.println(searchResultKeys[idx]);
                }
            }
            String[] keyWord2 = {"Value", "NOP"}; // Key_01000, Key_01001, Key_01002擾o
            Object[] searchResult2 = okuyamaClient.searchValue(keyWord2, OkuyamaClient.SEARCH_VALUE_TYPE_OR, "GRP1");
            if (searchResult2[0].equals("true")) {
                String[] searchResultKeys = (String[])searchResult2[1];
                for (int idx = 0; idx < searchResultKeys.length; idx++) {
                    System.out.println(searchResultKeys[idx]);
                }
            }

            // JavaScripts
            String script = "var dataValue; var retValue = ''; " +
                            "var execRet = '0'; if (dataValue.indexOf('ABC') != -1) " + 
                            "{   retValue = dataValue;   execRet = '1';}";

            String[] scriptResult = okuyamaClient.getValueScript("Key_01000", script);
            if (scriptResult[0].equals("true")) {
                System.out.println("ScriptɂValue'ABC'̕񂪑݂邱ƂmF");
            } else {
                System.out.println("ScriptɂValue'ABC'̕񂪑݂ȂƂmF");
            }

        } catch (Exception e) {
            e.printStackTrace();
        } 
    }
}
